#ifndef __TRUEBRANCH_HPP__
#define __TRUEBRANCH_HPP__

#include <plugin.hpp>
#include "guid.hpp"

#ifdef FAR2
#define PLUGINHKEY HKEY_CURRENT_USER
#define ex(x) x##Ex
#define PLUGINSETTINGS(settings) PluginSettings (settings)(PLUGIN_NAME, ::Info.RootKey)
#define INFOMESSAGE(Flags, MsgItems, Buttons) Info.Message(Info.ModuleNumber, (Flags), NULL, (MsgItems), ARRAYSIZE(MsgItems), (Buttons))
#define INFOMENU(x,y,z,f,t,b,c,bk,bc,m,s) Info.Menu(Info.ModuleNumber, (x), (y), (z), (f)|FMENU_USEEXT, (t), (b), (c), (bk), (bc), (const FarMenuItem *)(m), (s))
#define PanelControl Control
#define PANELCONTROLPARAM2 LONG_PTR
#else
#define PLUGINHKEY 0
#define ex(x) x
#define PLUGINSETTINGS(settings) PluginSettings (settings)(MainGuid, ::Info.SettingsControl)
#define INFOMESSAGE(Flags, MsgItems, Buttons) Info.Message(&MainGuid, NULL, (Flags), NULL, (MsgItems), ARRAYSIZE(MsgItems), (Buttons))
#define INFOMENU(x,y,z,f,t,b,c,bk,bc,m,s) Info.Menu(&MainGuid, NULL, (x), (y), (z), (f), (t), (b), (c), (bk), (bc), (m), (s))
#define PANELCONTROLPARAM2 void*
#endif

#ifdef FAR2
#define piGetFileName(pi)            ((pi)->FindData.lpwszFileName)
#define piGetAlternateFileName(pi)   ((pi)->FindData.lpwszAlternateFileName)
#define piGetFileAttributes(pi)      ((pi)->FindData.dwFileAttributes)
#define piGetCreationTime(pi)        ((pi)->FindData.ftCreationTime)
#define piGetLastAccessTime(pi)      ((pi)->FindData.ftLastAccessTime)
#define piGetLastWriteTime(pi)       ((pi)->FindData.ftLastWriteTime)
#define piGetFileSize(pi)            ((pi)->FindData.nFileSize)
#define piGetPackSize(pi)            ((pi)->FindData.nPackSize)
#define ffGetFileName(pi)            ((pi)->lpwszFileName)
#define ffGetAlternateFileName(pi)   ((pi)->lpwszAlternateFileName)
#define ffGetFileAttributes(pi)      ((pi)->dwFileAttributes)
#define ffGetCreationTime(pi)        ((pi)->ftCreationTime)
#define ffGetLastAccessTime(pi)      ((pi)->ftLastAccessTime)
#define ffGetLastWriteTime(pi)       ((pi)->ftLastWriteTime)
#define ffGetFileSize(pi)            ((pi)->nFileSize)
#define ffGetPackSize(pi)            ((pi)->nPackSize)
#define piPlugin(pi) ((pi).Plugin)
#else
#define piGetFileName(pi)            ((pi)->FileName)
#define piGetAlternateFileName(pi)   ((pi)->AlternateFileName)
#define piGetFileAttributes(pi)      ((pi)->FileAttributes)
#define piGetCreationTime(pi)        ((pi)->CreationTime)
#define piGetLastAccessTime(pi)      ((pi)->LastAccessTime)
#define piGetLastWriteTime(pi)       ((pi)->LastWriteTime)
#define piGetFileSize(pi)            ((pi)->FileSize)
#define piGetPackSize(pi)            ((pi)->AllocationSize)
#define ffGetFileName(pi)            ((pi)->FileName)
#define ffGetAlternateFileName(pi)   ((pi)->AlternateFileName)
#define ffGetFileAttributes(pi)      ((pi)->FileAttributes)
#define ffGetCreationTime(pi)        ((pi)->CreationTime)
#define ffGetLastAccessTime(pi)      ((pi)->LastAccessTime)
#define ffGetLastWriteTime(pi)       ((pi)->LastWriteTime)
#define ffGetFileSize(pi)            ((pi)->FileSize)
#define ffGetPackSize(pi)            ((pi)->AllocationSize)
#define piPlugin(pi) ((pi).PluginHandle && (pi).PluginHandle != INVALID_HANDLE_VALUE)
#endif

extern struct PluginStartupInfo Info;
extern struct FarStandardFunctions FSF;

inline const wchar_t *GetMsg(int MsgId)
{
  return Info.GetMsg(
#ifndef FAR2
    &MainGuid,
#else
    Info.ModuleNumber,
#endif
    MsgId
  );
}

#endif