#ifndef __TRUEBRANCHCLASS_HPP__
#define __TRUEBRANCHCLASS_HPP__

#include "plugin.hpp"

#ifdef FAR2
#define OPERATION_MODES int
#endif

enum riState { riActive, riIgnore, riDelete };

struct TRootItem
{
  bool Dir;
  riState State;
  TCHAR Name[512];
};

class BranchPanel
{
  private:
    int UpdateItems(void);
    bool GetFileInfoAndValidate(const TCHAR *FilePath,
#ifdef FAR2
      const FAR_FIND_DATA *SrcData,
#else
      const struct PluginPanelItem *SrcData,
#endif
      struct PluginPanelItem *DstData
    );
    void ProcessRemoveKey();
    void ProcessGoToKey();
    void ProcessToggleKey(int&, int = 2);
    int packRoot(void);
    void calcRoot(void);

    PluginPanelItem *BranchPanelItem;
    TRootItem *rootList;
    int rootItemsNumber;
    int BranchItemsNum;
    int BranchItemsMax;
    bool alreadyInUpdate;
  public:
    BranchPanel(int aRootItemsNum, TRootItem *aRootList);
    ~BranchPanel();
    bool AddItem(
#ifdef FAR2
      const FAR_FIND_DATA *ff,
#else
      const struct PluginPanelItem *ff,
#endif
      const TCHAR *Name, bool check = true
    );
    bool AddDir(const TCHAR *Name);
    int GetFindData(PluginPanelItem **pPanelItem,size_t *pItemsNumber,OPERATION_MODES OpMode);
#ifdef FAR2
    void GetOpenPanelInfo(struct OpenPluginInfo *Info);
#else
    void GetOpenPanelInfo(struct OpenPanelInfo *Info);
#endif
    void GetPluginInfo(struct PluginInfo *Info);
    int SetDirectory(const TCHAR *Dir,OPERATION_MODES OpMode);
    int ProcessKey(
#ifdef FAR2
      int Key,unsigned int ControlState
#else
      const INPUT_RECORD *Rec
#endif
    );
    int PutFiles(struct PluginPanelItem *PanelItem,int ItemsNumber,int Move,const TCHAR *SrcPath,OPERATION_MODES OpMode);
    HANDLE BeginPutFiles();
    void CommitPutFiles(HANDLE hRestoreScreen);
    int PutOneFile(const TCHAR* SrcPath, PluginPanelItem &PanelItem);

    int pressedEsc;
    TCHAR *currRoot, rootDir[MAX_PATH];
};

extern void add2RootList(TRootItem **rootList, int n, bool Dir, const TCHAR *Name, const TCHAR* CurDir);
extern BOOL ConfigAdv(void);

#endif
